//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Main.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
   m_Run = new _RunningLine(this->Handle);
   m_SnowPt = new TPoint[4*1024*1024];
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
   const int iNum=3600;
   int iCnt=0;
   TPoint aPt[iNum];

   m_Run->fnSetDrawPt(aPt,iCnt);
   m_Run->fnRunning();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
   delete  m_Run;
   delete [] m_SnowPt;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ScrollBar1Change(TObject *Sender)
{
   bool bMult;
   const int dCircle = 10;
   const int iNum=360.*dCircle;
   TPoint aPt[iNum];
   TPoint ps, pe;
   double dRaduisA, dRaduisB, dRaduisAB, dPol;
   double dSpn =0.0001;
   double dOrgx = (this->Width+Panel1->Width)/2.;
   double dOrgy = this->Height/2.;
   int iCnt=0;
   int iLv=1;
   TScrollBar *bar =(TScrollBar *)Sender;
   int iAct = bar->Name.SubString(bar->Name.LastDelimiter("r")+1,2).ToInt();
   switch (iAct){
   case 1: m_Run->fnSetElpLen(bar->Position);
   break;
   case 2: m_Run->fnSetLineWidth(bar->Position);
   break;
   case 3: m_Run->fnSetInterval(bar->Position);
   break;
   case 4: case 5:
      switch (RadioGroup1->ItemIndex){
      case 0: //̼wu C̼wu٬tu  Spiral of Uniform Velocity
      /*
      Ф{ : r = c
      ѼƤ{   : y = tsin(t), x = tcos(t)
     */
         ScrollBar4->Max=10000;
         ScrollBar4->Min=-10000;
         ScrollBar5->Max=200;
         ScrollBar5->Min=0;
         for (int i=0;i<iNum ;i++){
            if(ScrollBar5->Position)
               dPol = exp(ScrollBar5->Position*i*0.001*M_PI/180.);
            else
               dPol =i;
            aPt[i].x = dOrgx + dPol*(dSpn*ScrollBar4->Position)*cos(i*M_PI/180.);
            aPt[i].y = dOrgy + dPol*(dSpn*ScrollBar4->Position)*sin(i*M_PI/180.);
            iCnt++;
         }
      break;
      case 1: //~\u
      /*
      wq Sٶ~۽uC@ӰʶKt@Ӷꪺ~uʮɡAʶPWwI P
      y٬~\u EpicycloidCpϡAwꪺb| RAʶꪺb| rC
      ѼƤ{ :
                x = (R + r)*cost - r*cos( ((R + r)/r)*t )
                y = (R + r)*sint - r*sin( ((R + r)/r)*t )
      */
         ScrollBar4->Max=500;
         ScrollBar4->Min=1;
         ScrollBar5->Max=500;
         ScrollBar5->Min=1;
         dRaduisA = ScrollBar4->Position;
         dRaduisB = ScrollBar5->Position;
         dRaduisAB = dRaduisA + dRaduisB;
         for (int i=0;i<iNum ;i++){
            aPt[i].x = dOrgx + (dRaduisAB)*cos(i*M_PI/180.) - dRaduisB*cos((dRaduisAB/dRaduisB)*i*M_PI/180.);
            aPt[i].y = dOrgy + (dRaduisAB)*sin(i*M_PI/180.) - dRaduisB*sin((dRaduisAB/dRaduisB)*i*M_PI/180.);
            iCnt++;
         }
      break;
      case 2: //\u
      /*
         Nb| r  puۥb| R j uʡApW@wI PҦy٬\u
         ѼƤ{ :
                x = (R + r)*cost - r*cos( ((R + r)/r)*t )
                y = (R + r)*sint - r*sin( ((R + r)/r)*t )
      */
         ScrollBar4->Max=500;
         ScrollBar4->Min=1;
         ScrollBar5->Max=500;
         ScrollBar5->Min=1;
         dRaduisA = ScrollBar4->Position;
         dRaduisB = ScrollBar5->Position;
         dRaduisAB = dRaduisA - dRaduisB;
         for (int i=0;i<iNum ;i++){
            aPt[i].x = dOrgx + (dRaduisAB)*cos(i*M_PI/180.) + dRaduisB*cos((dRaduisAB/dRaduisB)*i*M_PI/180.);
            aPt[i].y = dOrgy + (dRaduisAB)*sin(i*M_PI/180.) - dRaduisB*sin((dRaduisAB/dRaduisB)*i*M_PI/180.);
            iCnt++;
         }
      break;
      case 3: //\u
      /*
         x = a(t - sint )
         y = a(1 - cost )
      */
         ScrollBar4->Max=500;
         ScrollBar4->Min=1;
         ScrollBar5->Max=500;
         ScrollBar5->Min=1;
         dRaduisA = ScrollBar4->Position;
         dRaduisB = ScrollBar5->Position;
         for (int i=0;i<iNum ;i++){
            aPt[i].x = -dOrgx/3. + dRaduisA*(i*M_PI/180.) - dRaduisB*sin(i*M_PI/180.);
            aPt[i].y = dOrgy     + dRaduisA               - dRaduisB*cos(i*M_PI/180.);
            iCnt++;
         }
      break;
      case 4: //ߦ޽u
      /*
         x = a*tan(t)
         y = a*cos(t)*cos(t)
      */
         ScrollBar4->Max=500;
         ScrollBar4->Min=-500;
         ScrollBar5->Max=500;
         ScrollBar5->Min=-500;
         dRaduisA = ScrollBar4->Position;
         dRaduisB = ScrollBar5->Position;
         iCnt=0;
         //for (int j=0 ;j<dCircle ;j++){
            for (int i=-89;i<90 ;i++){
               aPt[iCnt].x = dOrgx + dRaduisA*tan(i*M_PI/180.);
               aPt[iCnt].y = dOrgy + dRaduisA*cos(i*M_PI/180.)*cos(i*M_PI/180.);
               iCnt++;
            }
        // }
      break;
      case 5: //u
      /*
         r = acos(nc)  r = asin(nc)
      */
         ScrollBar4->Max=500;
         ScrollBar4->Min=-500;
         ScrollBar5->Max=36;
         ScrollBar5->Min=-36;
         dRaduisA = ScrollBar4->Position;
         if(ScrollBar5->Position >0)
            dRaduisB = ScrollBar5->Position;
         else if(ScrollBar5->Position <0)
            dRaduisB = -1/double(ScrollBar5->Position);
         else
            dRaduisB=1;
         iCnt=0;
         for (int i=0;i<iNum ;i++){
            dPol = dRaduisA*sin(i*dRaduisB*M_PI/180.);
            aPt[i].x = dOrgx + dPol*cos(i*M_PI/180.);
            aPt[i].y = dOrgy + dPol*sin(i*M_PI/180.);
            iCnt++;
         }
      break;
      case 6: //Tu
      /*
         Ф{ : r =a(1 + 2cos2c)/cosc
         ѼƤ{ :   x = a(1 + 2cos2c)
                      y = a(1 + 2cos2c)tanc
      */
         ScrollBar4->Max=500;
         ScrollBar4->Min=1;
         ScrollBar5->Max=36;
         ScrollBar5->Min=-36;
         dRaduisA = ScrollBar4->Position;
         iCnt=0;
         for (int i=1;i<180 ;i++){
            aPt[iCnt].x = dOrgx + dRaduisA*(1 + 2*cos(2*i*M_PI/180.));
            aPt[iCnt].y = dOrgy + dRaduisA*(1 + 2*cos(2*i*M_PI/180.))/(tan(i*M_PI/180.));
            iCnt++;
         }
         /*
         for (int i=181;i<360 ;i++){
            aPt[iCnt].x = dOrgx + -dRaduisA*(1 + 2*cos(2*i*M_PI/180.));
            aPt[iCnt].y = dOrgy + dRaduisA*(1 + 2*cos(2*i*M_PI/180.))/(tan(i*M_PI/180.));
            iCnt++;
         }
         */
      break;
       case 7: //u
      /*
         Ф{ r = a(sinc* sinc)/cosc
         ѼƤ{ : x = a(t*t)/(1 + t*t)
                    y = a(t*t*t)/(1 + t*t)
      */
         ScrollBar4->Max=500;
         ScrollBar4->Min=1;
         ScrollBar5->Max=36;
         ScrollBar5->Min=-36;
         dRaduisA = ScrollBar4->Position;
         iCnt=0;
         for (int i=1 ;i<90 ;i++){
            dPol = dRaduisA*sin(i*M_PI/180.)*tan(i*M_PI/180.);
            aPt[iCnt].x = dOrgx + dPol*cos(i*M_PI/180.);
            aPt[iCnt].y = dOrgy + dPol*sin(i*M_PI/180.);
            iCnt++;
         }
         for (int i=-89 ;i<0 ;i++){
            dPol = dRaduisA*sin(i*M_PI/180.)*tan(i*M_PI/180.);
            aPt[iCnt].x = dOrgx + dPol*cos(i*M_PI/180.);
            aPt[iCnt].y = dOrgy + dPol*sin(i*M_PI/180.);
            iCnt++;
         }
      break;
       case 8: //ᦱu
         ScrollBar4->Max=5000;
         ScrollBar4->Min=-5000;
         ScrollBar5->Max=890;
         ScrollBar5->Min=-890;
         dRaduisA = ScrollBar4->Position;
         dRaduisB = ScrollBar5->Position/10.;

         bMult = (dRaduisA<0) ? true : false;
         iLv = RadioGroup2->ItemIndex+1;
         iCnt=0;
         m_SnowPt[iCnt++] = TPoint(dOrgx + dRaduisA/2, dOrgy);
         m_SnowPt[iCnt++] = TPoint(dOrgx - dRaduisA/2, dOrgy);

         fnGetSnow(m_SnowPt, iCnt, dRaduisB, iLv, bMult) ;
         m_SnowPt[iCnt++] = m_SnowPt[0];
      break;
      }
      if(RadioGroup1->ItemIndex != 8)
         m_Run->fnSetDrawPt(aPt,iCnt);
      else
         m_Run->fnSetDrawPt(m_SnowPt,iCnt);
   break;
   }
   this->Refresh();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RadioGroup1Click(TObject *Sender)
{
   if(RadioGroup1->ItemIndex==8)
      RadioGroup2->Visible = true;
   else
      RadioGroup2->Visible = false;
   ScrollBar1Change(ScrollBar5);
}
//---------------------------------------------------------------------------


